#include <stdlib.h>
#include <graphics.h>
#include <conio.h>
#include <stdio.h>
#include <mem.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include "mouse.h"

 const char *IDRet = "ALK File";

 const char *Vlast[3] = {"Vyrovnana uloha","Sek. vyrovnana uloha","Degenerovana uloha"};

 const char BoxSizeX = 64, BoxSizeY = 33, PocrX = 37, PocrY = 22, InButton = 10, Checksize = 10;
 const struct { int X;
                int Y;
              } StatusLine = {22, 466};
 const int ClickFreq = 5000, ClickDelay = 1;

 class CBunka {
  public:
   unsigned int C, M, P;
   long X;
   float C2;
   void Vypis (int x, int y, char , int , int);
   void Focus (int x, int y);
   char Focused;
   char Color;
 };//Bunka

 class CTabulka {
  public:
   int DimX, DimY, DimX0, DimY0;
   CBunka Tab[51][51];
   int SizeX, SizeY;
   int PocX, PocY;
   struct {
    int X, Y;
   } Selected;
   int Vlastp[3];
   int MovedX, MovedY;
   char IndexyD[51][4];
   char IndexyO[51][4];
   int Solved;
   CTabulka ();
   void SetDim (int x, int y);
   void DrawPlace ();
   void DrawIndex ();
   void Fill (char mark);
   void Move (char );
   void Vlastnosti ();
   void DrawAll ();
   void Clear ();
   void MoveAll (char x, char y, char mark);
   char Check ();
   void Fiktivni (char , long );
   void Sever ();
   void Nejlepsi ();
   void Centra ();
 };//CTabulka

 class CButton {
   int X1,X2,Y1,Y2;
   char *Text;
   char Key;
   char CountHighlited;
  public:
   CButton (int x1, int y1, int x2, int y2, char *text, char key, char ch);
   int Draw ();
   char Inside (int x, int y);
 };//CButton

 class CCheckBut {
   int X,Y;
   char Checked;
  public:
   CCheckBut (int , int , char );
   void Draw ();
   void Check ();
   void Uncheck ();
   char Inside (int , int );
 };//CCheckBut

 CMouse Mouse;
 CButton *Buttons[9];
 CCheckBut *Checks[6];
 CTabulka Tabulka;
 char Nastaveni[6] = {0,1,0,0,0,0};
 char GraphOn = 0;
 int ScrollPos = 221;
 char ScrollDif = -1;
 int kTab = 0, bStar = 0, kLeft = 0, kRight = 0, kUp = 0, kDown = 0, bE = 0,
  bC = 0, bP = 0, bS = 0, bZ = 0, bK = 0, bU = 0, bJ = 0, bN = 0, bR = 0,
  bM = 0, bO = 0, bF1 = 0, bEsc = 0;
 char *Soubor = "Uloha.alk";
 char JeCislo = 0;
 int pokrac;

void ErrorMsg (const char *text)
{
 if (GraphOn) { closegraph (); GraphOn = 0; }//if
 printf (text);
 exit (1);
}//ErrorMsg

inline long min (long a, long b)
{
 return (a > b) ? b : a;
}//min

inline long min (long a, long b, long c)
{
 long d;
 d = (a > b) ? b : a;
 return (d > c) ? c : d;
}//min

void StatusLineWrite (int poz1, char *text1, int poz2, char *text2, int poz3, char *text3)
{
 setfillstyle (SOLID_FILL, DARKGRAY);
 bar (2, 462, 637, 477);
 setcolor (WHITE);
 outtextxy (StatusLine.X + poz1, StatusLine.Y, text1);
 outtextxy (StatusLine.X + poz2, StatusLine.Y, text2);
 outtextxy (StatusLine.X + poz3, StatusLine.Y, text3);
}//StatusLineWrite

void Beep (int freq, int del)
{
 sound (freq); delay (del); nosound ();
}//Beep

void Long2Ret (long c, char t[6], char sum)
{
 long cifry[5];
 cifry[0] = c / 10000;
 cifry[1] = (c - cifry[0] * 10000) / 1000;
 cifry[2] = (c - (cifry[0] * 10000 + cifry[1] * 1000)) / 100;
 cifry[3] = (c - (cifry[0] * 10000 + cifry[1] * 1000 + cifry[2] * 100)) / 10;
 cifry[4] = c % 10;
 if (!sum) {
  if (cifry[2] == 0) t[0] = ' '; else t[0] = cifry[2] + '0';
  if ((cifry[3] == 0) && (cifry[2] == 0)) t[1] = ' '; else t[1] = cifry[3] + '0';
  t[2] = cifry[4] + '0'; t[3] = '\0';
 }//if
 else {
  if (cifry[0] == 0) t[0] = ' '; else t[0] = cifry[0] + '0';
  if ((cifry[1] == 0) && (cifry[0] == 0)) t[1] = ' '; else t[1] = cifry[1] + '0';
  if ((cifry[2] == 0) && (cifry[1] == 0) && (cifry[0] == 0)) t[2] = ' '; else t[2] = cifry[2] + '0';
  if ((cifry[3] == 0) && (cifry[2] == 0) && (cifry[1] == 0) && (cifry[0] == 0)) t[3] = ' '; else t[3] = cifry[3] + '0';
  t[4] = cifry[4] + '0'; t[5] = '\0';
 }//else
}//Long2Ret

void CBunka::Vypis (int sx, int sy, char sum, int px, int py)
{
 int x = Tabulka.PocX + PocrX + BoxSizeX * sx + 1;
 int y = Tabulka.PocY + PocrY + BoxSizeY * sy + 1;
 setcolor (BLACK);
 char t[6];
 if (!sum) {
  Long2Ret (C,t,0);
  outtextxy (x + 5, y + 5, t);
 }//if
 if ((Nastaveni[3]) && (!sum)) {
  Long2Ret (P,t,0);
  outtextxy (x + 35, y + 5, t);
 }//if
 if ((Nastaveni[2]) && (!sum)) {
  Long2Ret (M,t,0);
  outtextxy (x + 5, y + 20, t);
 }//if
 if (!sum) {
  Long2Ret (X,t,0);
  outtextxy (x + 35, y + 20, t);
 }//if
 else {
  Long2Ret (X,t,1);
  if (Tabulka.Solved) {
   long sa = 0, sb = 0;
   for (int i = 0; i < Tabulka.DimX; i++) sa += Tabulka.Tab[py][i].X;
   for (int j = 0; j < Tabulka.DimY; j++) sb += Tabulka.Tab[j][px].X;
   if (sa != Tabulka.Tab[py][50].X) Tabulka.Tab[py][50].Color = RED;
   else Tabulka.Tab[py][50].Color = BLACK;
   if (sb != Tabulka.Tab[50][px].X) Tabulka.Tab[50][px].Color = RED;
   else Tabulka.Tab[50][px].Color = BLACK;
   setcolor (Tabulka.Tab[py][px].Color);
  }//if
  outtextxy (x + 15, y + 20, t);
 }//else
}//Vypis

void CBunka::Focus (int x, int y)
{
 setcolor (YELLOW);
 rectangle (x, y, x + 30, y + 15);
 rectangle (x + 31, y, x + 62, y + 15);
 rectangle (x, y + 16, x + 30, y + 31);
 rectangle (x + 31, y + 16, x + 62, y + 31);
 setcolor (GREEN);
 switch (Focused) {
  case 0 : { rectangle (x, y, x + 30, y + 15); break; }
  case 1 : { rectangle (x + 31, y, x + 62, y + 15); break; }
  case 2 : { rectangle (x, y + 16, x + 30, y + 31); break; }
  case 3 : rectangle (x + 31, y + 16, x + 62, y + 31);
 }//switch
}//Focus

void CTabulka::SetDim (int x, int y)
{
 int pomx = (x < DimX) ? x : DimX, pomy = (y < DimY) ? y : DimY;
 for (int j = pomy; j < y; j++)
  for (int k = pomx; k < x; k++) {
   Tab[j][k].C = Tab[j][k].M = Tab[j][k].P = 0;
   Tab[j][k].X = 0;
  }//for
 DimX = x; DimY = y;
 DimX0 = (x < 7) ? x : 7, DimY0 = (y < 7) ? y : 7;
 SizeX = PocrX + (DimX0 + 1) * BoxSizeX + 2;
 SizeY = PocrY + (DimY0 + 1) * BoxSizeY + 2;
 PocX = (640 - SizeX) / 2;
 PocY = (290 - SizeY) / 2 + 22;
 Selected.X = Selected.Y = 0;
 MovedX = MovedY = 0;
 Solved = 0;
 int l;
 for (l = 0; l < 50; l++)
  if (l < 9) {
   IndexyD[l][0] = IndexyO[l][0] = ' ';
   IndexyD[l][1] = 'D'; IndexyO[l][1] = 'O';
   IndexyD[l][2] = IndexyO[l][2] = l + '1';
   IndexyD[l][3] = IndexyO[l][3] = '\0';
  }//if
  else {
   IndexyD[l][0] = 'D'; IndexyO[l][0] = 'O';
   IndexyD[l][1] = IndexyO[l][1] = (l + 1) / 10 + '0';
   IndexyD[l][2] = IndexyO[l][2] = (l + 1) % 10 + '0';
   IndexyD[l][3] = IndexyO[l][3] = '\0';
  }//else
 IndexyD[l][0] = IndexyO[l][0] = IndexyD[l][2] = IndexyO[l][2] = ' ';
 IndexyD[l][3] = IndexyO[l][3] = '\0';
 IndexyD[l][1] = 'b'; IndexyO[50][1] = 'a';
}//SetDim

CTabulka::CTabulka ()
{
 DimX = DimY = 7;
 for (int j = 0; j < 51; j++)
  for (int k = 0; k < 51; k++) {
   Tab[j][k].C = Tab[j][k].M = Tab[j][k].P = 0;
   Tab[j][k].X = 0;
   if ((j == 50) || (k == 50)) Tab[j][k].Focused = 3;
   else Tab[j][k].Focused = 0;
   Tab[j][k].Color = BLACK;
  }//for
 SetDim (7,7);
}//CTabulka

void CTabulka::Vlastnosti ()
{
 //dodelat
 Vlastp[0] = 0; Vlastp[1] = 0; Vlastp[2] = 0;
 long sa = 0, sb = 0;
 int j,i;
 for (i = 0; i < DimY; i++) sa += (long)Tab[i][50].X;
 for (j = 0; j < DimX; j++) sb += (long)Tab[50][j].X;
 if (sa == sb) Vlastp[0] = 1;
 if (Nastaveni[2]) {
  Vlastp[1] = 1;
  for (i = 0; i < DimY; i++) {
   sa = 0;
   for (j = 0; j < DimX; j++) sa += (long)Tab[i][j].M;
   if (sa < Tab[i][50].X) { Vlastp[1] = 0; break; }//if
  }//for
  if (Vlastp[1])
  for (j = 0; j < DimX; j++) {
   sb = 0;
   for (i = 0; i < DimY; i++) sb += (long)Tab[i][j].M;
   if (sb < Tab[50][j].X) { Vlastp[1] = 0; break; }//if
  }//for
 }//if
 sa = 0;
 for (i = 0; i < DimY; i++) for (j = 0; j < DimX; j++)
  if (Tab[i][j].C * Tab[i][j].X != 0) sa++;
 if (sa < DimX + DimY - 1) Vlastp[2] = 1;
 setfillstyle (SOLID_FILL, WHITE);
 bar (442, 322, 616, 374);
 for (int w = 0; w < 3; w++) {
  if (Vlastp[w]) setcolor (BLACK);
  else setcolor (LIGHTGRAY);
  outtextxy (450, 329 + 15 * w, Vlast[w]);
 }//for
 sa = 0;
 for (i = 0; i < DimY; i++) for (j = 0; j < DimX; j++)
  if (!Nastaveni[3]) sa += (long)Tab[i][j].C * Tab[i][j].X;
  else sa += (long)Tab[i][j].C * Tab[i][j].X + Tab[i][j].P * ((Tab[i][j].X > 0) ? 1 : 0);
 setfillstyle (SOLID_FILL, CYAN);
 bar (475, 385, 639, 405);
 char t[10];
 ltoa (sa, t, 10);
 setcolor (BLACK);
 outtextxy (480, 390, t);
}//Vlastnosti

void CTabulka::DrawPlace ()
{
 setcolor (BLUE);
 rectangle (PocX, PocY, PocX + SizeX, SizeY + PocY);
 rectangle (PocX + 1, PocY + 1, PocX + SizeX - 1, SizeY + PocY - 1);
 setfillstyle (SOLID_FILL, WHITE);
 bar (PocX + 2, PocY + 2, PocX + SizeX - 2, SizeY + PocY - 2);
 setcolor (BLACK);
 line (PocX + PocrX - 2, PocY + 2, PocX + PocrX - 2, SizeY + PocY - 2);
 line (PocX + 2, PocY + PocrY - 2, PocX + SizeX - 2, PocY + PocrY - 2);
}//DrawPlace

void CTabulka::DrawIndex ()
{
 setcolor (BLACK);
 setfillstyle (SOLID_FILL, WHITE);
 bar (PocX + PocrX, PocY + 2, PocX + SizeX - 2, PocY + PocrY - 3);
 bar (PocX + 2, PocY + PocrY, PocX + PocrX - 3, PocY + SizeY - 2);
 char *pom;
 int i,j;
 for (i = 0; i < DimX0; i++) {
  pom = IndexyO[i + MovedX];
  outtextxy (PocX + PocrX + i * BoxSizeX + 22, PocY + 7, pom);
 }//for
 for (j = 0; j < DimY0; j++) {
  pom = IndexyD[j + MovedY];
  outtextxy (PocX + 7, PocY + PocrY + j * BoxSizeY + 13, pom);
 }//for
 pom = IndexyO[50];
 outtextxy (PocX + PocrX + i * BoxSizeX + 22, PocY + 7, pom);
 pom = IndexyD[50];
 outtextxy (PocX + 7, PocY + PocrY + j * BoxSizeY + 13, pom);
}//DrawIndex

void CTabulka::Fill (char mark)
{
 setfillstyle (SOLID_FILL, WHITE);
 setcolor (BLACK);
 bar (PocX + PocrX, PocY + PocrY, PocX + SizeX - 2, SizeY + PocY - 2);
 for (int k = 0; k <= DimX0; k++) {
  line (PocX + PocrX + BoxSizeX * k, PocY + PocrY, PocX + PocrX + BoxSizeX * k, PocY + SizeY - 2);
 }//for
 for (int l = 0; l <= DimY0; l++) {
  line (PocX + PocrX, PocY + PocrY + BoxSizeY * l, PocX + SizeX - 2, PocY + PocrY + BoxSizeY * l);
 }//for
 if (mark)
  if ((Selected.X >= MovedX) && ((Selected.X < MovedX + 7) || (Selected.X == 50)) &&
   (Selected.Y >= MovedY) && ((Selected.Y < MovedY + 7) || (Selected.Y == 50))) {
   setfillstyle (SOLID_FILL, YELLOW);
   if ((Selected.X != 50) && (Selected.Y != 50)) {
    bar (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1, PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + BoxSizeX - 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + BoxSizeY - 1);
    Tab[Selected.Y][Selected.X].Focus (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1);
   }//if
   else {
    if (Selected.X == 50)
     bar (PocX + PocrX + BoxSizeX * DimX0 + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1, PocX + PocrX + BoxSizeX * DimX0 + BoxSizeX, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + BoxSizeY - 1);
    if (Selected.Y == 50)
     bar (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * DimY0 + 1, PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + BoxSizeX - 1, PocY + PocrY + BoxSizeY * DimY0 + BoxSizeY);
   }//else
  }//if
 int i,j;
 for (i = 0; i < DimY0; i++)
  for (j = 0; j < DimX0; j++)
   Tab[i + MovedY][j + MovedX].Vypis (j, i, 0, 0, 0);
 for (i = 0; i < DimY0; i++) Tab[i + MovedY][50].Vypis (DimX0, i, 1, 50, i + MovedY);
 for (j = 0; j < DimX0; j++) Tab[50][j + MovedX].Vypis (j, DimY0, 1, j + MovedX, 50);
 Vlastnosti ();
}//Fill

void CTabulka::Move (char dir)
{
 if ((Selected.X >= MovedX) && (Selected.X < MovedX + 7) &&
  (Selected.Y >= MovedY) && (Selected.Y < MovedY + 7)) {
  setfillstyle (SOLID_FILL, WHITE);
  bar (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1, PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + BoxSizeX - 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + BoxSizeY - 1);
  Tab[Selected.Y][Selected.X].Vypis (Selected.X - MovedX, Selected.Y - MovedY, 0, 0, 0);
 }//if
 if (Selected.X == 50) {
  setfillstyle (SOLID_FILL, WHITE);
  bar (PocX + PocrX + BoxSizeX * DimX0 + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1, PocX + PocrX + BoxSizeX * DimX0 + BoxSizeX, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + BoxSizeY - 1);
  Tab[Selected.Y][50].Vypis (DimX0, Selected.Y - MovedY, 1, 50, Selected.Y);
 }//if
 if (Selected.Y == 50) {
  setfillstyle (SOLID_FILL, WHITE);
  bar (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * DimY0 + 1, PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + BoxSizeX - 1, PocY + PocrY + BoxSizeY * DimY0 + BoxSizeY);
  Tab[50][Selected.X].Vypis (Selected.X - MovedX, DimY0, 1, Selected.X, 50);
 }//if
 if (dir == 0) {
  if (Selected.X == 50) Selected.X = DimX - 1; else
  if (Selected.X > 0) Selected.X--;
 }//if
 if (dir == 1) if (Selected.X < DimX - 1) Selected.X++; else Selected.X = 50;
 if (dir == 2) {
  if (Selected.Y == 50) Selected.Y = DimY - 1; else
  if (Selected.Y > 0) Selected.Y--;
 }//if
 if (dir == 3) if (Selected.Y < DimY - 1) Selected.Y++; else Selected.Y = 50;
 if (Selected.X < MovedX) MoveAll (-1, 0, 0);
 if ((Selected.X >= MovedX + 7) && (Selected.X != 50)) MoveAll (1, 0, 0);
 if (Selected.Y < MovedY) MoveAll (0, -1, 0);
 if ((Selected.Y >= MovedY + 7) && (Selected.Y != 50)) MoveAll (0, 1, 0);
 if ((Selected.X >= MovedX) && (Selected.X < MovedX + 7) &&
  (Selected.Y >= MovedY) && (Selected.Y < MovedY + 7)) {
  setfillstyle (SOLID_FILL, YELLOW);
  bar (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1, PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + BoxSizeX - 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + BoxSizeY - 1);
  Tab[Selected.Y][Selected.X].Focus (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1);
  Tab[Selected.Y][Selected.X].Vypis (Selected.X - MovedX, Selected.Y - MovedY, 0, 0, 0);
 }//if
 if (Selected.X == 50) {
  setfillstyle (SOLID_FILL, YELLOW);
  bar (PocX + PocrX + BoxSizeX * DimX0 + 1, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + 1, PocX + PocrX + BoxSizeX * DimX0 + BoxSizeX, PocY + PocrY + BoxSizeY * (Selected.Y - MovedY) + BoxSizeY - 1);
  Tab[Selected.Y][50].Vypis (DimX0, Selected.Y - MovedY, 1, 50, Selected.Y);
 }//if
 if (Selected.Y == 50) {
  setfillstyle (SOLID_FILL, YELLOW);
  bar (PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + 1, PocY + PocrY + BoxSizeY * DimY0 + 1, PocX + PocrX + BoxSizeX * (Selected.X - MovedX) + BoxSizeX - 1, PocY + PocrY + BoxSizeY * DimY0 + BoxSizeY);
  Tab[50][Selected.X].Vypis (Selected.X - MovedX, DimY0, 1, Selected.X, 50);
 }//if
}//Move

void CTabulka::Clear ()
{
 setfillstyle (SOLID_FILL, CYAN);
 bar (40, 20, 600, 315);
}//Clear

void CTabulka::DrawAll ()
{
 Clear (); DrawPlace (); DrawIndex (); Fill (1);
}//DrawAll

void CTabulka::MoveAll (char x, char y, char mark)
{
 if ((x != 0) && (DimX > 7)) {
  if ((x == -1) && (MovedX > 0)) MovedX--;
  if ((x == 1) && (MovedX < DimX - DimX0)) MovedX++;
 }//if
 if ((y != 0) && (DimY > 7)) {
  if ((y == -1) && (MovedY > 0)) MovedY--;
  if ((y == 1) && (MovedY < DimY - DimY0)) MovedY++;
 }//if
 DrawIndex (); Fill (mark);
}//Move

CButton::CButton (int x1, int y1, int x2, int y2, char *text, char key, char ch)
{
 X1 = x1; X2 = x2; Y1 = y1; Y2 = y2; Text = text; Key = key;
 CountHighlited = ch;
}//CButton

int CButton::Draw ()
{
 char targstr[100] = "\0", pomstr[100];
 int dif = 0;
 setcolor (BLACK);
 if (X2 == 0) X2 = X1 + textwidth (Text) + 2 * InButton;
 if (Y2 == 0) Y2 = Y1 + textheight (Text) + 2 * InButton;
 rectangle (X1, Y1, X2, Y2);
 setfillstyle (SOLID_FILL, LIGHTGRAY);
 bar (X1 + 1, Y1 + 1, X2 - 1, Y2 - 1);
 memcpy (targstr, strchr (Text, Key), CountHighlited);
 *(targstr + CountHighlited) = '\0';
 if (targstr != NULL) {
  dif = strchr (Text, Key) - Text;
  memcpy (pomstr, Text, dif);
  *(pomstr + dif) = '\0';
  dif = textwidth (pomstr);
 }//if
 setcolor (BLACK);
 int deltax = ((X2 - X1) - textwidth (Text)) / 2;
 int deltay = ((Y2 - Y1) - textheight (Text)) / 2;
 outtextxy (X1 + deltax, Y1 + deltay, Text);
 setcolor (WHITE);
 outtextxy (X1 + deltax + dif, Y1 + deltay, targstr);
 return X2 - X1;
}//Draw

char CButton::Inside (int x, int y)
{
 if ((x >= X1) && (x <= X2) && (y >= Y1) && (y <= Y2)) return 1;
 else return 0;
}//Inside

CCheckBut::CCheckBut (int x, int y, char checked)
{
 X = x; Y = y; Checked = checked;
}//CCheckBut

void CCheckBut::Draw ()
{
 setcolor (BLACK);
 rectangle (X, Y, X + Checksize, Y + Checksize);
 setfillstyle (SOLID_FILL, LIGHTGRAY);
 bar (X + 1, Y + 1, X + Checksize - 1, Y + Checksize - 1);
 if (Checked) {
  line (X + 1, Y + 1, X + Checksize - 1, Y + Checksize - 1);
  line (X + Checksize - 1, Y + 1, X + 1, Y + Checksize - 1);
 }//if
}//Draw

void CCheckBut::Check ()
{
 Mouse.Hide ();
 setcolor (BLACK);
 line (X + 1, Y + 1, X + Checksize - 1, Y + Checksize - 1);
 line (X + Checksize - 1, Y + 1, X + 1, Y + Checksize - 1);
 Mouse.Display ();
 Checked = 1;
}//Check

void CCheckBut::Uncheck ()
{
 Mouse.Hide ();
 setcolor (LIGHTGRAY);
 line (X + 1, Y + 1, X + Checksize - 1, Y + Checksize - 1);
 line (X + Checksize - 1, Y + 1, X + 1, Y + Checksize - 1);
 Mouse.Display ();
 Checked = 0;
}//Uncheck

char CCheckBut::Inside (int x, int y)
{
 if ((x >= X) && (x <= X + Checksize) && (y >= Y) && (y <= Y + Checksize)) return 1;
 else return 0;
}//Inside

void DrawText (int x1, int y1, char *text, char key, char ch)
{
 char targstr[100] = "\0", pomstr[100];
 int dif = 0;
 setcolor (BLACK);
 memcpy (targstr, strchr (text, key), ch);
 *(targstr + ch) = '\0';
 if (targstr != NULL) {
  dif = strchr (text, key) - text;
  memcpy (pomstr, text, dif);
  *(pomstr + dif) = '\0';
  dif = textwidth (pomstr);
 }//if
 setcolor (BLACK);
 outtextxy (x1, y1, text);
 setcolor (WHITE);
 outtextxy (x1 + dif, y1, targstr);
}//DrawText

void ScrollTitle ()
{
 setcolor (GREEN);
 outtextxy (ScrollPos,7,"* * *  A L O K A C E  * * *");
 ScrollPos += ScrollDif;
 setcolor (RED);
 outtextxy (ScrollPos,7,"* * *  A L O K A C E  * * *");
 if ((ScrollPos == 2) || (ScrollPos == 436)) ScrollDif = -ScrollDif;
}//ScrollTitle

void Napis_Soubor ()
{
 setfillstyle (SOLID_FILL, CYAN);
 bar (495, 405, 639, 425);
 setcolor (BROWN);
 outtextxy (500, 410, Soubor);
}//Napis_Soubor

void DrawMain ()
{
 setfillstyle (SOLID_FILL, CYAN);
 bar (0, 0, 639, 479);
 setfillstyle (SOLID_FILL, GREEN);
 bar (2, 2, 637, 17);
 ScrollTitle ();
 Tabulka.DrawAll ();
 setcolor (BLACK);
 DrawText (300, 322, "Maximalizovat", 'M', 1);
 DrawText (300, 339, "Minimalizovat", 'n', 1);
 DrawText (300, 356, "Mezni zpusobilost", 'e', 1);
 DrawText (300, 373, "Sek. nakl. char.", 'k', 1);
 DrawText (300, 390, "Reprezentant", 'z', 1);
 DrawText (300, 407, "Prirazovaci", 'P', 1);
 setcolor (BLACK);
 outtextxy (440, 390, "HKF:");
 outtextxy (440, 410, "Soubor:");
 Napis_Soubor ();
 setcolor (YELLOW);
 rectangle (440, 320, 618, 376);
 rectangle (441, 321, 617, 375);
 setcolor (WHITE);
 rectangle (440,432,618,448);
 setcolor (LIGHTCYAN);
 outtextxy (462, 437, "Jan Outrata, 1999");
 setfillstyle (SOLID_FILL, DARKGRAY);
 bar (2, 462, 637, 477);
 Mouse.SetHRange (22,390);
 Mouse.SetVRange (320,450);
 Mouse.SetPos (22,320);
}//DrawMain

void DrawButtons ()
{
 int buty = 29, difbuty = 5, difbutx = 10, poc1 = 22, poc2, pocy = 320, poc3;
 static CButton Button3 (poc1, pocy + 3 * (buty + difbuty), 0, 0, "Rozmer (*)", '*', 1);
 int maxbutx = Button3.Draw ();
 Buttons[0] = &Button3;
 static CButton Button0 = CButton (poc1, pocy, poc1 + maxbutx, 0, "Nova", 'o', 1);
 static CButton Button1 = CButton (poc1, pocy + buty + difbuty, poc1 + maxbutx, 0, "Nacist", 'c', 1);
 static CButton Button2 = CButton (poc1, pocy + 2 * (buty + difbuty), poc1 + maxbutx, 0, "Ulozit", 'U', 1);
 poc2 = poc1 + maxbutx + difbutx;
 static CButton Button6 (poc2, pocy + 2 * (buty + difbuty), 0, 0, "Sdruzena centra", 'S', 1);
 maxbutx = Button6.Draw ();
 Buttons[4] = &Button6;
 static CButton Button4 = CButton (poc2, pocy, poc2 + maxbutx, 0, "SZ roh", 'r', 1);
 static CButton Button5 = CButton (poc2, pocy + buty + difbuty, poc2 + maxbutx, 0, "Nejlepsi", 'j', 1);
 static CButton Button7 = CButton (poc2, pocy + 3 * (buty + difbuty), poc2 + maxbutx, 0, "Napoveda (F1)", 'F', 2);
 poc3 = poc2 + maxbutx + difbutx;
 static CButton Button8 = CButton (poc3, pocy + 3 * (buty + difbuty), 0, 0, "Konec (Esc)", 'E', 3);
 Button0.Draw (); Button1.Draw (); Button2.Draw (); Button4.Draw ();
 Button5.Draw (); Button7.Draw (); Button8.Draw ();
 Buttons[0] = &Button0;
 Buttons[1] = &Button1;
 Buttons[2] = &Button2;
 Buttons[3] = &Button3;
 Buttons[4] = &Button4;
 Buttons[5] = &Button5;
 Buttons[6] = &Button6;
 Buttons[7] = &Button7;
 Buttons[8] = &Button8;
 static CCheckBut Check0 = CCheckBut (poc3, 320, 0);
 static CCheckBut Check1 = CCheckBut (poc3, 337, 1);
 static CCheckBut Check2 = CCheckBut (poc3, 354, 0);
 static CCheckBut Check3 = CCheckBut (poc3, 371, 0);
 static CCheckBut Check4 = CCheckBut (poc3, 388, 0);
 static CCheckBut Check5 = CCheckBut (poc3, 405, 0);
 Check0.Draw (); Check1.Draw (); Check2.Draw (); Check3.Draw ();
 Check4.Draw (); Check5.Draw ();
 Checks[0] = &Check0; Checks[1] = &Check1; Checks[2] = &Check2;
 Checks[3] = &Check3; Checks[4] = &Check4; Checks[5] = &Check5;
}//DrawButtons

char SetDimension ()
{
 char vysl = 0;
 int DX = 100, DY = 55;
 int Startx = (640 - DX) / 2;
 int Starty = (320 - DY) / 2;
 setcolor (BLUE);
 setfillstyle (SOLID_FILL, WHITE);
 rectangle (Startx, Starty, Startx + DX, Starty + DY);
 rectangle (Startx + 1, Starty + 1, Startx + DX - 1, Starty + DY - 1);
 bar (Startx + 2, Starty + 2, Startx + DX - 2, Starty + DY - 2);
 setcolor (BLACK);
 outtextxy (Startx + 20, Starty + 12, "Rozmer :");
 int key;
 int pos = Startx + 17, pos0 = pos;
 outtextxy (pos + 17, Starty + 32, " x ");
 rectangle (pos - 5, Starty + 27, pos + 71, Starty + 43);
 char numstr[2] = {'0','\0'}, rad;
 int RX[2] = {0,0}, RY[2] = {0,0};
 do {
  fflush (stdin);
  key = getch ();
  if ((pos == pos0) || (pos == pos0 + 50)) rad = 1; else rad = 0;
  if ((key == 8) && (pos > pos0)) {
   if (pos == pos0 + 50) pos -= 40; else pos -= 10;
   bar (pos, Starty + 32, pos + 8, Starty + 40);
   if (pos < pos0 + 30) RX[rad] = 0; else RY[rad] = 0;
  }//if
  if (pos < pos0 + 70) {
   if ((key > 47) && (key < 58)) {
    numstr[0] = key;
    outtextxy (pos, Starty + 32, numstr);
    pos += 10;
    if (pos < pos0 + 30) RX[rad] = key - 48; else RY[rad] = key - 48;
   }//if
   if ((key == ' ') && ((pos ==  pos0) || (pos == pos0 + 50))) {
    outtextxy (pos, Starty + 32, "0");
    pos += 10;
    if (pos < pos0 + 30) RX[rad] = 0; else RY[rad] = 0;
   }//if
  }//if
  if (pos == pos0 + 20) pos += 30;
  if (key == 13) {
   int x = RX[1] * 10 + RX[0], y = RY[1] * 10 + RY[0];
   if (x < 1) x = 1; if (x > 50) x = 50;
   if (y < 1) y = 1; if (y > 50) y = 50;
   Tabulka.SetDim (y, x);
   vysl = 1;
  }//if
 } while ((key != 27) && (key != 13));
 Tabulka.DrawAll ();
 return vysl;
}//SetDimension

void Cislo (int x, int y, int key, int &p)
{
 long c;
 int pomx1, pomx2, pomy1, pomy2;
 if ((x != 50) && (y != 50)) {
  switch (Tabulka.Tab[y][x].Focused) {
   case 0 : { c = Tabulka.Tab[y][x].C; pomx1 = 1; pomx2 = 29; pomy1 = 1; pomy2 = 14; break; }
   case 1 : { c = Tabulka.Tab[y][x].P; pomx1 = 32; pomx2 = 61; pomy1 = 1; pomy2 = 14; break; }
   case 2 : { c = Tabulka.Tab[y][x].M; pomx1 = 1; pomx2 = 29; pomy1 = 17; pomy2 = 30; break; }
   case 3 : { c = Tabulka.Tab[y][x].X; pomx1 = 32; pomx2 = 61; pomy1 = 17; pomy2 = 30; }
  }//switch
  if (Nastaveni[5]) { if (key < 2) c = key; }
  else
   if (!p) c = key;
   else if (c < 100) c = c * 10 + key;
  switch (Tabulka.Tab[y][x].Focused) {
   case 0 : { Tabulka.Tab[y][x].C = (unsigned int)c; break; }
   case 1 : { Tabulka.Tab[y][x].P = (unsigned int)c; break; }
   case 2 : { Tabulka.Tab[y][x].M = (unsigned int)c; break; }
   case 3 : Tabulka.Tab[y][x].X = c;
  }//switch
  setfillstyle (SOLID_FILL, YELLOW);
  bar (Tabulka.PocX + PocrX + BoxSizeX * (x - Tabulka.MovedX) + 1 + pomx1, Tabulka.PocY + PocrY + BoxSizeY * (y - Tabulka.MovedY) + 1 + pomy1, Tabulka.PocX + PocrX + BoxSizeX * (x - Tabulka.MovedX) + 1 + pomx2, Tabulka.PocY + PocrY + BoxSizeY * (y - Tabulka.MovedY) + 1 + pomy2);
  Tabulka.Tab[y][x].Vypis (x - Tabulka.MovedX, y - Tabulka.MovedY, 0, 0, 0);
 }//if
 else {
  c = Tabulka.Tab[y][x].X; pomx1 = 1; pomx2 = 61; pomy1 = 17; pomy2 = 30;
  if (Nastaveni[5]) { if (key < 2) c = key; }
  else
   if (!p) c = key;
   else if (c < 10000) c = c * 10 + key;
  Tabulka.Tab[y][x].X = c;
  setfillstyle (SOLID_FILL, YELLOW);
  if (x == 50) {
   bar (Tabulka.PocX + PocrX + BoxSizeX * Tabulka.DimX0 + 1 + pomx1, Tabulka.PocY + PocrY + BoxSizeY * (y - Tabulka.MovedY) + 1 + pomy1, Tabulka.PocX + PocrX + BoxSizeX * Tabulka.DimX0 + 1 + pomx2, Tabulka.PocY + PocrY + BoxSizeY * (y - Tabulka.MovedY) + 1 + pomy2);
   Tabulka.Tab[y][50].Vypis (Tabulka.DimX0, y - Tabulka.MovedY, 1, 50, y);
  }//if
  else {
   bar (Tabulka.PocX + PocrX + BoxSizeX * (x - Tabulka.MovedX) + 1 + pomx1, Tabulka.PocY + PocrY + BoxSizeY * Tabulka.DimY0 + 1 + pomy1, Tabulka.PocX + PocrX + BoxSizeX * (x - Tabulka.MovedX) + 1 + pomx2, Tabulka.PocY + PocrY + BoxSizeY * Tabulka.DimY0 + 1 + pomy2);
   Tabulka.Tab[50][x].Vypis (x - Tabulka.MovedX, Tabulka.DimY0, 1, x, 50);
  }//else
 }//else
 if (!p) JeCislo = 1;
 p = 1;
}//Cislo

void JeCislof ()
{
 if ((JeCislo) && (!pokrac)) {
  JeCislo = 0;
  Tabulka.Tab[Tabulka.Selected.Y][50].Vypis (Tabulka.DimX0, Tabulka.Selected.Y - Tabulka.MovedY, 1, 50, Tabulka.Selected.Y);
  Tabulka.Tab[50][Tabulka.Selected.X].Vypis (Tabulka.Selected.X - Tabulka.MovedX, Tabulka.DimY0, 1, Tabulka.Selected.X, 50);
 }//if
 Tabulka.Vlastnosti ();
}//JeCislof

void CountC2 ()
{
 int i, j, k;
 if ((Nastaveni[2]) && (Nastaveni[3]))
  for (i = 0; i < Tabulka.DimY; i++) for (j = 0; j < Tabulka.DimX; j++)
   if (Tabulka.Tab[i][j].M) Tabulka.Tab[i][j].C2 = Tabulka.Tab[i][j].C + (float)Tabulka.Tab[i][j].P / Tabulka.Tab[i][j].M;
   else Tabulka.Tab[i][j].C2 = Tabulka.Tab[i][j].C;
 if (Nastaveni[4]) {
  long sa, sb, sv = 0;
  for (i = 0; i < Tabulka.DimY; i++) for (j = 0; j < Tabulka.DimX; j++)
   sv += (long)Tabulka.Tab[i][j].C;
  for (i = 0; i < Tabulka.DimY; i++) for (j = 0; j < Tabulka.DimX; j++) {
   sb = 0;
   for (k = 0; k < Tabulka.DimY; k++) sb += (long)Tabulka.Tab[k][j].C;
   sa = 0;
   for (k = 0; k < Tabulka.DimX; k++) sa += (long)Tabulka.Tab[i][k].C;
   Tabulka.Tab[i][j].C2 = (Tabulka.Tab[i][j].C - (float)sb / Tabulka.DimY) - (float)sa / Tabulka.DimX + (float)sv / (Tabulka.DimX * Tabulka.DimY);
  }//for
 }//if
}//CountC2

void Ulozit ()
{
 int DX = 135, DY = 55;
 int Startx = (640 - DX) / 2;
 int Starty = (320 - DY) / 2;
 setcolor (BLUE);
 setfillstyle (SOLID_FILL, WHITE);
 rectangle (Startx, Starty, Startx + DX, Starty + DY);
 rectangle (Startx + 1, Starty + 1, Startx + DX - 1, Starty + DY - 1);
 bar (Startx + 2, Starty + 2, Startx + DX - 2, Starty + DY - 2);
 setcolor (BLACK);
 outtextxy (Startx + 38, Starty + 12, "Soubor :");
 int key;
 int pos = Startx + 17;
 outtextxy (pos + 70, Starty + 32, ".alk");
 rectangle (pos - 5, Starty + 27, pos + 106, Starty + 43);
 char str[9] = "\0";
 char spos = 0;
 do {
  fflush (stdin);
  key = getch ();
  if ((key > 32) && (key < 127) && (spos < 8)) {
   str[spos + 1] = str[spos]; str[spos] = (char)key; spos++;
   bar (pos, Starty + 32, pos + 69, Starty + 42);
   setcolor (BLACK);
   outtextxy (pos + 61 - (spos - 1) * 8, Starty + 32, str);
  }//if
  if ((key == 8) && (spos > 0)) {
   str[spos - 1] = str[spos]; spos--;
   bar (pos, Starty + 32, pos + 69, Starty + 42);
   setcolor (BLACK);
   outtextxy (pos + 61 - (spos - 1) * 8, Starty + 32, str);
  }//if
  if (key == 13) {
   char *S2 = '\0';
   strcpy (S2,Soubor);
   for (int i = 0; i < spos; i++) Soubor[i] = str[i];
   Soubor[spos] = '.'; Soubor[spos + 1] = 'a'; Soubor[spos + 2] = 'l'; Soubor[spos + 3] = 'k'; Soubor[spos + 4] = '\0';
   int File = open (Soubor, O_CREAT | O_WRONLY | O_BINARY);
   if (File == -1) {
    StatusLineWrite (0,"Chyba pri vytvareni souboru !",0,"",0,"");
    Beep (400, 100);
    delay (2000);
    StatusLineWrite (0,"",0,"",0,"");
    strcpy (Soubor,S2);
   }//if
   else {
    long sum = write (File, IDRet, 8) +
    write (File, Nastaveni, sizeof Nastaveni) +
    write (File, &Tabulka.DimX, 2) +
    write (File, &Tabulka.DimY, 2) +
    write (File, Tabulka.Tab, sizeof Tabulka.Tab) +
    write (File, &Tabulka.Selected, sizeof Tabulka.Selected) +
    write (File, &Tabulka.MovedX, 2) +
    write (File, &Tabulka.MovedY, 2) +
    write (File, &Tabulka.Solved, 2);
    close (File);
    if (sum == /*41644L*/-23892) StatusLineWrite (0,"Ulozeno.",0,"",0,"");
    else {
     StatusLineWrite (0,"Chyba pri ukladani souboru !",0,"",0,"");
     strcpy (Soubor,S2);
    }//else
    Beep (400, 100);
    delay (2000);
    StatusLineWrite (0,"",0,"",0,"");
    Napis_Soubor ();
   }//else
  }//if
 } while ((key != 27) && (key != 13));
 Tabulka.DrawAll ();
}//Ulozit

void Nacist ()
{
 int DX = 135, DY = 55;
 int Startx = (640 - DX) / 2;
 int Starty = (320 - DY) / 2;
 setcolor (BLUE);
 setfillstyle (SOLID_FILL, WHITE);
 rectangle (Startx, Starty, Startx + DX, Starty + DY);
 rectangle (Startx + 1, Starty + 1, Startx + DX - 1, Starty + DY - 1);
 bar (Startx + 2, Starty + 2, Startx + DX - 2, Starty + DY - 2);
 setcolor (BLACK);
 outtextxy (Startx + 38, Starty + 12, "Soubor :");
 int key;
 int pos = Startx + 17;
 outtextxy (pos + 70, Starty + 32, ".alk");
 rectangle (pos - 5, Starty + 27, pos + 106, Starty + 43);
 char str[9] = "\0";
 char spos = 0;
 do {
  fflush (stdin);
  key = getch ();
  if ((key > 32) && (key < 127) && (spos < 8)) {
   str[spos + 1] = str[spos]; str[spos] = (char)key; spos++;
   bar (pos, Starty + 32, pos + 69, Starty + 42);
   setcolor (BLACK);
   outtextxy (pos + 61 - (spos - 1) * 8, Starty + 32, str);
  }//if
  if ((key == 8) && (spos > 0)) {
   str[spos - 1] = str[spos]; spos--;
   bar (pos, Starty + 32, pos + 69, Starty + 42);
   setcolor (BLACK);
   outtextxy (pos + 61 - (spos - 1) * 8, Starty + 32, str);
  }//if
  if (key == 13) {
   char *S2 = '\0';
   strcpy (S2,Soubor);
   for (int i = 0; i < spos; i++) Soubor[i] = str[i];
   Soubor[spos] = '.'; Soubor[spos + 1] = 'a'; Soubor[spos + 2] = 'l'; Soubor[spos + 3] = 'k'; Soubor[spos + 4] = '\0';
   int File = open (Soubor, O_RDONLY | O_BINARY);
   if (File == -1) {
    StatusLineWrite (0,"Chyba pri otevirani souboru !",0,"",0,"");
    Beep (400, 100);
    delay (2000);
    StatusLineWrite (0,"",0,"",0,"");
    strcpy (Soubor,S2);
   }//if
   else {
    char OK = 1;
    char IDRet0[9];
    read (File, IDRet0, 8);
    IDRet0[8] = '\0';
    if (strcmp (IDRet, IDRet0)) {
     StatusLineWrite (0,"Soubor neni souborem pro tento program !",0,"",0,"");
     strcpy (Soubor,S2);
     Beep (400, 100);
     delay (2000);
     StatusLineWrite (0,"",0,"",0,"");
     OK = 0;
    }//if
    else {
     long sum = 8 +
     read (File, Nastaveni, sizeof Nastaveni) +
     read (File, &Tabulka.DimX, 2) +
     read (File, &Tabulka.DimY, 2) +
     read (File, Tabulka.Tab, sizeof Tabulka.Tab) +
     read (File, &Tabulka.Selected, sizeof Tabulka.Selected) +
     read (File, &Tabulka.MovedX, 2) +
     read (File, &Tabulka.MovedY, 2) +
     read (File, &Tabulka.Solved, 2);
     close (File);
     if (sum != /*41644L*/-23892) {
      StatusLineWrite (0,"Chyba pri nacitani souboru !",0,"",0,"");
      strcpy (Soubor,S2);
      Beep (400, 100);
      delay (2000);
      StatusLineWrite (0,"",0,"",0,"");
      OK = 0;
     }//if
     if (OK) {
      int pom[5] = {Tabulka.Selected.X, Tabulka.Selected.Y, Tabulka.MovedX, Tabulka.MovedY, Tabulka.Solved};
      Tabulka.SetDim (Tabulka.DimX, Tabulka.DimY);
      Tabulka.Selected.X = pom[0]; Tabulka.Selected.Y = pom[1]; Tabulka.MovedX = pom[2]; Tabulka.MovedY = pom[3]; Tabulka.Solved = pom[4];
      for (int i = 0; i < 6; i++)
       if (Nastaveni[i]) Checks[i]->Check ();
       else Checks[i]->Uncheck ();
     }//if
     Napis_Soubor ();
    }//else
   }//else
  }//if
 } while ((key != 27) && (key != 13));
 Tabulka.DrawAll ();
}//Nacist

void Nova ()
{
 StatusLineWrite (0,"Ulozit ulohu? (a/n)",0,"",0,"");
 Beep (400, 100);
 int key;
 do {
  fflush (stdin);
  key = getch ();
  if (key == 'a') {
   Ulozit ();
  }//if
 } while ((key != 'a') && (key != 'n'));
 StatusLineWrite (0,"",0,"",0,"");
 for (int j = 0; j < 51; j++)
  for (int k = 0; k < 51; k++) {
   Tabulka.Tab[j][k].C = Tabulka.Tab[j][k].M = Tabulka.Tab[j][k].P = 0;
   Tabulka.Tab[j][k].X = 0;
   if ((j == 50) || (k == 50)) Tabulka.Tab[j][k].Focused = 3;
   else Tabulka.Tab[j][k].Focused = 0;
   Tabulka.Tab[j][k].Color = BLACK;
  }//for
 if (SetDimension ()) {
  Nastaveni[0] = 0; Nastaveni[1] = 1; Nastaveni[2] = 0; Nastaveni[3] = 0;
  Nastaveni[4] = 0; Nastaveni[5] = 0;
  Checks[0]->Uncheck (); Checks[1]->Check (); Checks[2]->Uncheck ();
  Checks[3]->Uncheck (); Checks[4]->Uncheck (); Checks[5]->Uncheck ();
  Soubor = "Uloha.alk"; Napis_Soubor ();
 }//if
}//Nova

char CTabulka::Check ()
{
 char zadana = 1;
 int chyba;
 char *chybastr = "\0";
 for (int i = 0; i < DimY; i++)
  if (Tab[i][50].X < 1) { zadana = 0; chyba = i; break; }//if
 if (zadana) {
  for (int i = 0; i < DimX; i++)
   if (Tab[50][i].X < 1) { zadana = 0; chyba = i; break; }//if
 }//if
 else {
  itoa (chyba + 1, chybastr, 10);
  StatusLineWrite (0,"Spatne zadani: Nulova dispozice dodavatele c.",362,chybastr,0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
  return 0;
 }//else
 if (zadana) {
  long sa = 0, sb = 0;
  int j,i;
  for (i = 0; i < DimY; i++) sa += (long)Tab[i][50].X;
  for (j = 0; j < DimX; j++) sb += (long)Tab[50][j].X;
  if (sa > sb) {
   zadana = 0;
   StatusLineWrite (0,"Uloha neni vyrovnana. Pridat fiktivniho odberatele? (a/n)",0,"",0,"");
   Beep (400, 100);
   int key;
   do {
    fflush (stdin);
    key = getch ();
    if (key == 'a') {
     Fiktivni (0,sa - sb);
     zadana = 1;
    }//if
   } while ((key != 'a') && (key != 'n'));
   StatusLineWrite (0,"",0,"",0,"");
  }//if
  if (sa < sb) {
   zadana = 0;
   StatusLineWrite (0,"Uloha neni vyrovnana. Pridat fiktivniho dodavatele? (a/n)",0,"",0,"");
   Beep (400, 100);
   int key;
   do {
    fflush (stdin);
    key = getch ();
    if (key == 'a') {
     Fiktivni (1,sb - sa);
     zadana = 1;
    }//if
   } while ((key != 'a') && (key != 'n'));
   StatusLineWrite (0,"",0,"",0,"");
  }//if
  return zadana;
 }//if
 else {
  itoa (chyba + 1, chybastr, 10);
  StatusLineWrite (0,"Spatne zadani: Nulova kapacita odberatele c.",355,chybastr,0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
  return 0;
 }//else
}//Check

void CTabulka::Fiktivni (char co, long x)
{
 unsigned int sazba = 0;
 char *ktera = "\0", *znam = "\0";
 if (Nastaveni[0]) { ktera = "Preferencni"; znam = "-> 0"; }//if
 else { ktera = "Prohibitivni"; znam = ">> 0"; }//else
 int DX = 172, DY = 55;
 int Startx = (640 - DX) / 2;
 int Starty = (320 - DY) / 2;
 setcolor (BLUE);
 setfillstyle (SOLID_FILL, WHITE);
 rectangle (Startx, Starty, Startx + DX, Starty + DY);
 rectangle (Startx + 1, Starty + 1, Startx + DX - 1, Starty + DY - 1);
 bar (Startx + 2, Starty + 2, Startx + DX - 2, Starty + DY - 2);
 setcolor (BLACK);
 outtextxy (Startx + 10, Starty + 12, ktera);
 outtextxy (Startx + 110, Starty + 12, "sazba :");
 int key;
 int pos = Startx + 50;
 outtextxy (pos + 35, Starty + 32, znam);
 rectangle (pos - 5, Starty + 27, pos + 75, Starty + 43);
 char str[9] = "\0";
 char spos = 0;
 char max, mspos;
 if (Nastaveni[5]) { max = 50; mspos = 1; }//if
 else { max = 58; mspos = 3; }//else
 do {
  fflush (stdin);
  key = getch ();
  if ((key > 47) && (key < max) && (spos < mspos)) {
   str[spos + 1] = str[spos]; str[spos] = (char)key; spos++;
   bar (pos, Starty + 32, pos + 30, Starty + 42);
   setcolor (BLACK);
   outtextxy (pos + 20 - (spos - 1) * 8, Starty + 32, str);
  }//if
  if ((key == 8) && (spos > 0)) {
   str[spos - 1] = str[spos]; spos--;
   bar (pos, Starty + 32, pos + 30, Starty + 42);
   setcolor (BLACK);
   outtextxy (pos + 20 - (spos - 1) * 8, Starty + 32, str);
  }//if
  if (key == 13) {
   sazba = atoi (str);
  }//if
 } while ((key != 13) || (spos == 0));
 if (!co) {
  SetDim (DimX + 1, DimY);
  Tab[50][DimX - 1].X = x;
  for (int i = 0; i < DimY; i++) Tab[i][DimX - 1].C = sazba;
 }//if
 else {
  SetDim (DimX, DimY + 1);
  Tab[DimY - 1][50].X = x;
  for (int i = 0; i < DimX; i++) Tab[DimY - 1][i].C = sazba;
 }//else
 DrawAll ();
}//Fiktivni

void CTabulka::Sever ()
{
 if (!Check ()) return;
 long a[50], b[50], mini;
 int i, j, i0, j0;
 char s = 0, k = 0;
 for (i = 0; i < 50; i++) { a[i] = Tab[i][50].X; b[i] = Tab[50][i].X; }//for
 for (i = 0; i < 50; i++) for (j = 0; j < 50; j++) Tab[i][j].X = 0;
 i = 0; j = 0;
 while ((i < DimY) && (j < DimX)) {
  if (!Nastaveni[2]) mini = min (a[i], b[j]); else mini = min (a[i], b[j], Tab[i][j].M);
  Tab[i][j].X = mini;
  a[i] -= mini; b[j] -= mini;
  if ((a[i] != 0) && (b[j] != 0)) {
   if (!s) { i0 = i; j0 = j; s = 1; k = 0; }//if
   if (!k) j++; else i++;
   if (j == DimX) { j = j0; k = 1; }//if
   if (i == DimY) { i = i0 + 1; j = j0 + 1; s = 0; }//if
   continue;
  }//if
  if (a[i] == 0) { i++; s = 0; }//if
  if (b[j] == 0) { j++; s = 0; }//if
 }//while
 s = 1;
 for (i = 0; i < DimY; i++)
  if (a[i]) { Tab[i][50].Color = RED; s = 0; } else Tab[i][50].Color = BLACK;
 for (j = 0; j < DimX; j++)
  if (b[j]) { Tab[50][j].Color = RED; s = 0; } else Tab[50][j].Color = BLACK;
 Fill (1);
 Solved = 1;
 if (s) StatusLineWrite (0,"Uloha uplne vyresena.",0,"",0,"");
 else StatusLineWrite (0,"Uloha neni uplne vyresena. Je potreba dalsich partneru.",0,"",0,"");
 Beep (400, 100);
 delay (2000);
 StatusLineWrite (0,"",0,"",0,"");
}//Sever

void CTabulka::Nejlepsi ()
{
 if (!Check ()) return;
 long a[50], b[50], mini;
 char c0[50][50];
 int i, j, i0, j0, i1 = 0, j1 = 0;
 char s = 1;
 for (i = 0; i < 50; i++) { a[i] = Tab[i][50].X; b[i] = Tab[50][i].X; }//for
 for (i = 0; i < 50; i++) for (j = 0; j < 50; j++) c0[i][j] = 0;
 for (i = 0; i < DimY; i++) for (j = 0; j < DimX; j++) {
  if (!Nastaveni[4]) {
   if ((Nastaveni[1]) && (Tab[i][j].C > Tab[i1][j1].C)) { i1 = i; j1 = j; }//if
   if ((Nastaveni[0]) && (Tab[i][j].C < Tab[i1][j1].C)) { i1 = i; j1 = j; }//if
  }//if
  else {
   if ((Nastaveni[1]) && (Tab[i][j].C2 > Tab[i1][j1].C2)) { i1 = i; j1 = j; }//if
   if ((Nastaveni[0]) && (Tab[i][j].C2 < Tab[i1][j1].C2)) { i1 = i; j1 = j; }//if
  }//else
 }//for
 for (i = 0; i < 50; i++) for (j = 0; j < 50; j++) Tab[i][j].X = 0;
 i = 0; j = 0;
 while (s) {
  s = 0; i0 = i1; j0 = j1;
  for (i = 0; i < DimY; i++) for (j = 0; j < DimX; j++)
   if (!c0[i][j]) {
    if (!Nastaveni[4]) {
     if ((Nastaveni[1]) && (Tab[i][j].C < Tab[i0][j0].C)) { i0 = i; j0 = j; s = 1; }//if
     if ((Nastaveni[0]) && (Tab[i][j].C > Tab[i0][j0].C)) { i0 = i; j0 = j; s = 1; }//if
    }//if
    else {
     if ((Nastaveni[1]) && (Tab[i][j].C2 < Tab[i0][j0].C2)) { i0 = i; j0 = j; s = 1; }//if
     if ((Nastaveni[0]) && (Tab[i][j].C2 > Tab[i0][j0].C2)) { i0 = i; j0 = j; s = 1; }//if
    }//else
    if (!s) { s = 1; i0 = i; j0 = j; }//if
   }//if
  if (s) {
   c0[i0][j0] = 1;
   if (!Nastaveni[2]) mini = min (a[i0], b[j0]); else mini = min (a[i0], b[j0], Tab[i0][j0].M);
   Tab[i0][j0].X = mini;
   a[i0] -= mini; b[j0] -= mini;
  }//if
 }//while
 s = 1;
 for (i = 0; i < DimY; i++)
  if (a[i]) { Tab[i][50].Color = RED; s = 0; } else Tab[i][50].Color = BLACK;
 for (j = 0; j < DimX; j++)
  if (b[j]) { Tab[50][j].Color = RED; s = 0; } else Tab[50][j].Color = BLACK;
 Fill (1);
 Solved = 1;
 if (s) StatusLineWrite (0,"Uloha uplne vyresena.",0,"",0,"");
 else StatusLineWrite (0,"Uloha neni uplne vyresena. Je potreba dalsich partneru.",0,"",0,"");
 Beep (400, 100);
 delay (2000);
 StatusLineWrite (0,"",0,"",0,"");
}//Nejlepsi

float tabc[2][50], tabm[2][50], r[50];
long b0[50], a1, a2;
char r0[50];
int i, j, j0, j1;

/*void Centra_2 ()
{
 j1 = 0; char s = 1; long mini;
 for (j = 0; j < Tabulka.DimX; j++) {
  r[j] = tabc[0][j] - tabc[1][j];
  r0[j] = 0;
 }//for
 for (j = 0; j < Tabulka.DimX; j++) {
  if ((Nastaveni[1]) && (r[j] > r[j1])) j1 = j;
  if ((Nastaveni[0]) && (r[j] < r[j1])) j1 = j;
 }//for
 for (j = 0; j < Tabulka.DimX; j++) { tabx[0][j] = 0; tabx[1][j] = 0; }//for
 j = 0;
 while (s) {
  s = 0; j0 = j1;
  for (j = 0; j < Tabulka.DimX; j++)
   if (!r0[j]) {
    if ((Nastaveni[1]) && (r[j] < r[j0])) { j0 = j; s = 1; }//if
    if ((Nastaveni[0]) && (r[j] > r[j0])) { j0 = j; s = 1; }//if
    if (!s) { s = 1; j0 = j; }//if
   }//if
  if (s) {
   r0[j0] = 1;
   if (!Nastaveni[2]) mini = min (a1, b0[j0]); else mini = min (a1, b0[j0], tabm[0][j0]);
   tabx[0][j0] = mini;
   a1 -= mini; b0[j0] -= mini;
  }//if
 }//while
 for (j = 0; j < Tabulka.DimX; j++) r0[j] = 0;
 s = 1; j = 0;
 while (s) {
  s = 0; j0 = j1;
  for (j = 0; j < Tabulka.DimX; j++)
   if (!r0[j]) {
    if ((Nastaveni[1]) && (r[j] < r[j0])) { j0 = j; s = 1; }//if
    if ((Nastaveni[0]) && (r[j] > r[j0])) { j0 = j; s = 1; }//if
    if (!s) { s = 1; j0 = j; }//if
   }//if
  if (s) {
   r0[j0] = 1;
   if (!Nastaveni[2]) mini = min (a2, b0[j0]); else mini = min (a2, b0[j0], tabm[1][j0]);
   tabx[1][j0] = mini;
   a2 -= mini; b0[j0] -= mini;
  }//if
 }//while
}//Centra_R*/

void Centra_R (int e, int f)
{
 if (e == f) {
  for (j = 0; j < Tabulka.DimX; j++) Tabulka.Tab[e][j].X = b0[j];
 }//if
 else
  if (e + 1 == f) {
   long tabx[2][50];
   a1 = a2 = 0;
   for (i = e; i < e + 1; i++) a1 += Tabulka.Tab[i][50].X;
   for (; i < f + 1; i++) a2 += Tabulka.Tab[i][50].X;
   for (j = 0; j < Tabulka.DimX; j++) {
    for (i = e; i < e + 1; i++) {
     if (!Nastaveni[4])
      tabc[0][j] += Tabulka.Tab[i][j].C * (float)Tabulka.Tab[i][50].X / a1;
     else
      tabc[0][j] += Tabulka.Tab[i][j].C2 * (float)Tabulka.Tab[i][50].X / a1;
     tabm[0][j] += Tabulka.Tab[i][j].M * (float)Tabulka.Tab[i][50].X / a1;
    }//for
    for (; i < f + 1; i++) {
     if (!Nastaveni[4])
      tabc[1][j] += Tabulka.Tab[i][j].C * (float)Tabulka.Tab[i][50].X / a2;
     else
      tabc[1][j] += Tabulka.Tab[i][j].C2 * (float)Tabulka.Tab[i][50].X / a2;
     tabm[1][j] += Tabulka.Tab[i][j].M * (float)Tabulka.Tab[i][50].X / a2;
    }//for
   }//for
   //Centra_2 ();
   j1 = 0; char s = 1; long mini;
 for (j = 0; j < Tabulka.DimX; j++) {
  r[j] = tabc[0][j] - tabc[1][j];
  r0[j] = 0;
 }//for
 for (j = 0; j < Tabulka.DimX; j++) {
  if ((Nastaveni[1]) && (r[j] > r[j1])) j1 = j;
  if ((Nastaveni[0]) && (r[j] < r[j1])) j1 = j;
 }//for
 for (j = 0; j < Tabulka.DimX; j++) { tabx[0][j] = 0; tabx[1][j] = 0; }//for
 j = 0;
 while (s) {
  s = 0; j0 = j1;
  for (j = 0; j < Tabulka.DimX; j++)
   if (!r0[j]) {
    if ((Nastaveni[1]) && (r[j] < r[j0])) { j0 = j; s = 1; }//if
    if ((Nastaveni[0]) && (r[j] > r[j0])) { j0 = j; s = 1; }//if
    if (!s) { s = 1; j0 = j; }//if
   }//if
  if (s) {
   r0[j0] = 1;
   if (!Nastaveni[2]) mini = min (a1, b0[j0]); else mini = min (a1, b0[j0], tabm[0][j0]);
   tabx[0][j0] = mini;
   a1 -= mini; b0[j0] -= mini;
  }//if
 }//while
 for (j = 0; j < Tabulka.DimX; j++) r0[j] = 0;
 s = 1; j = 0;
 while (s) {
  s = 0; j0 = j1;
  for (j = 0; j < Tabulka.DimX; j++)
   if (!r0[j]) {
    if ((Nastaveni[1]) && (r[j] < r[j0])) { j0 = j; s = 1; }//if
    if ((Nastaveni[0]) && (r[j] > r[j0])) { j0 = j; s = 1; }//if
    if (!s) { s = 1; j0 = j; }//if
   }//if
  if (s) {
   r0[j0] = 1;
   if (!Nastaveni[2]) mini = min (a2, b0[j0]); else mini = min (a2, b0[j0], tabm[1][j0]);
   tabx[1][j0] = mini;
   a2 -= mini; b0[j0] -= mini;
  }//if
 }//while

   for (j = 0; j < Tabulka.DimX; j++) Tabulka.Tab[e][j].X = tabx[0][j];
   for (j = 0; j < Tabulka.DimX; j++) Tabulka.Tab[f][j].X = tabx[1][j];
  }//if
  else {
   long tabx[2][50];
   a1 = a2 = 0;
   for (i = e; i < ((f + 1) - e) / 2 + e; i++) a1 += Tabulka.Tab[i][50].X;
   for (; i < f + 1; i++) a2 += Tabulka.Tab[i][50].X;
   for (j = 0; j < Tabulka.DimX; j++) {
    for (i = e; i < ((f + 1) - e) / 2 + e; i++) {
     if (!Nastaveni[4])
      tabc[0][j] += Tabulka.Tab[i][j].C * (float)Tabulka.Tab[i][50].X / a1;
     else
      tabc[0][j] += Tabulka.Tab[i][j].C2 * (float)Tabulka.Tab[i][50].X / a1;
     tabm[0][j] += Tabulka.Tab[i][j].M * (float)Tabulka.Tab[i][50].X / a1;
    }//for
    for (; i < f + 1; i++) {
     if (!Nastaveni[4])
      tabc[1][j] += Tabulka.Tab[i][j].C * (float)Tabulka.Tab[i][50].X / a2;
     else
      tabc[1][j] += Tabulka.Tab[i][j].C2 * (float)Tabulka.Tab[i][50].X / a2;
     tabm[1][j] += Tabulka.Tab[i][j].M * (float)Tabulka.Tab[i][50].X / a2;
    }//for
   }//for
   //Centra_2 ();
   j1 = 0; char s = 1; long mini;
 for (j = 0; j < Tabulka.DimX; j++) {
  r[j] = tabc[0][j] - tabc[1][j];
  r0[j] = 0;
 }//for
 for (j = 0; j < Tabulka.DimX; j++) {
  if ((Nastaveni[1]) && (r[j] > r[j1])) j1 = j;
  if ((Nastaveni[0]) && (r[j] < r[j1])) j1 = j;
 }//for
 for (j = 0; j < Tabulka.DimX; j++) { tabx[0][j] = 0; tabx[1][j] = 0; }//for
 j = 0;
 while (s) {
  s = 0; j0 = j1;
  for (j = 0; j < Tabulka.DimX; j++)
   if (!r0[j]) {
    if ((Nastaveni[1]) && (r[j] < r[j0])) { j0 = j; s = 1; }//if
    if ((Nastaveni[0]) && (r[j] > r[j0])) { j0 = j; s = 1; }//if
    if (!s) { s = 1; j0 = j; }//if
   }//if
  if (s) {
   r0[j0] = 1;
   if (!Nastaveni[2]) mini = min (a1, b0[j0]); else mini = min (a1, b0[j0], tabm[0][j0]);
   tabx[0][j0] = mini;
   a1 -= mini; b0[j0] -= mini;
  }//if
 }//while
 for (j = 0; j < Tabulka.DimX; j++) r0[j] = 0;
 s = 1; j = 0;
 while (s) {
  s = 0; j0 = j1;
  for (j = 0; j < Tabulka.DimX; j++)
   if (!r0[j]) {
    if ((Nastaveni[1]) && (r[j] < r[j0])) { j0 = j; s = 1; }//if
    if ((Nastaveni[0]) && (r[j] > r[j0])) { j0 = j; s = 1; }//if
    if (!s) { s = 1; j0 = j; }//if
   }//if
  if (s) {
   r0[j0] = 1;
   if (!Nastaveni[2]) mini = min (a2, b0[j0]); else mini = min (a2, b0[j0], tabm[1][j0]);
   tabx[1][j0] = mini;
   a2 -= mini; b0[j0] -= mini;
  }//if
 }//while

   for (j = 0; j < Tabulka.DimX; j++) b0[j] = tabx[0][j];
   Centra_R (e, ((f + 1) - e) / 2 + e - 1);
   for (j = 0; j < Tabulka.DimX; j++) b0[j] = tabx[1][j];
   Centra_R (((f + 1) - e) / 2 + e, f);
  }//else
}//Centra

void CTabulka::Centra ()
{
 if (!Check ()) return;
 for (int j = 0; j < DimX; j++) b0[j] = Tab[50][j].X;
 Centra_R (0, DimY - 1);
 char s = 1;
 long a[50], b[50];
 for (i = 0; i < 50; i++) a[i] = b[i] = 0;
 for (i = 0; i < DimY; i++) {
  for (j = 0; j < DimX; j++) a[i] += Tab[i][j].X;
  if (a[i] != Tab[i][50].X) { Tab[i][50].Color = RED; s = 0; } else Tab[i][50].Color = BLACK;
 }//for
 for (j = 0; j < DimX; j++) {
  for (i = 0; i < DimY; i++) b[j] += Tab[i][j].X;
  if (b[j] != Tab[50][j].X) { Tab[50][j].Color = RED; s = 0; } else Tab[50][j].Color = BLACK;
 }//for
 Fill (1);
 Solved = 1;
 if (s) StatusLineWrite (0,"Uloha uplne vyresena.",0,"",0,"");
 else StatusLineWrite (0,"Uloha neni uplne vyresena. Je potreba dalsich partneru.",0,"",0,"");
 Beep (400, 100);
 delay (2000);
 StatusLineWrite (0,"",0,"",0,"");
}//Centra

void Napoveda ()
{
 Mouse.Hide ();
 setfillstyle (SOLID_FILL, BLACK);
 setcolor (BROWN);
 int x1 = 0, x2 = 639, y1 = 0, y2 = 479;
 bar (x1,y1,x2,y2);
 rectangle (x1,y1,x2,y2);
 rectangle (x1 + 2,y1 + 2,x2 - 2,y2 - 2);
 rectangle (x1 + 4,y1 + 4,x2 - 4,y2 - 4);
 rectangle (x1 + 6,y1 + 6,x2 - 6,y2 - 6);
 setcolor (YELLOW);
 settextstyle (1, 0, 2);
 outtextxy (x1 + 80, y1 + 15,"\"Horke\" klavesy, tlacitka a zaskrtavaci policka");
 line (x1 + 80, y1 + 45, x1 + 560, y1 + 45);
 setcolor (WHITE);
 settextstyle (0, 0, 0);
 outtextxy (x1 + 30, y1 + 65,"Klavesy :");
 outtextxy (x1 + 40, y1 + 85,"Sipky     Pohyb po bunkach v tabulce");
 outtextxy (x1 + 40, y1 + 95,"Tab       Pohyb kurzoru v bunce (cislo v kurzoru bude editovano)");
 outtextxy (x1 + 30, y1 + 115,"Tlacitka & Zaskrtavaci pole:");
 outtextxy (x1 + 40, y1 + 135,"pozn. : Kazde ma svou \"horkou\" klavesu");
 outtextxy (x1 + 40, y1 + 150,"Rozmer             Zmena rozmeru tabulky (poctu dodavatelu a odberatelu)");
 outtextxy (x1 + 200, y1 + 160,"- rozmer je urcen dvema dvoucifernymi cisly,");
 outtextxy (x1 + 200, y1 + 170,"  v pripade jednociferneho cisla se musi zadat jako");
 outtextxy (x1 + 200, y1 + 180,"  prvni cifra nula (klavesou 0 nebo mezernikem)");
 outtextxy (x1 + 40, y1 + 190,"Napoveda           Tato napoveda");
 outtextxy (x1 + 40, y1 + 200,"Konec              Ukonceni programu");
 outtextxy (x1 + 40, y1 + 215,"Nova               Nova uloha");
 outtextxy (x1 + 40, y1 + 225,"Nacist             Nacteni ulozene ulohy z disku");
 outtextxy (x1 + 40, y1 + 235,"Ulozit             Ulozit aktualni stav ulohy na disk");
 outtextxy (x1 + 40, y1 + 255,"SZ roh             Reseni ulohy metodou \"Severozapadniho rohu\"");
 outtextxy (x1 + 40, y1 + 265,"Nejlepsi           Reseni ulohy metodou \"Dosazovani nejlepsich\"");
 outtextxy (x1 + 40, y1 + 275,"Sdruzena centra    Reseni ulohy metodou \"Sdruzenych center\"");
 outtextxy (x1 + 40, y1 + 295,"Maximalizovat      Maximalizace ulohy");
 outtextxy (x1 + 40, y1 + 305,"Minimalizovat      Minimalizace ulohy");
 outtextxy (x1 + 40, y1 + 315,"Mezni zpusobilost  Mezni zpusobilost distribuce");
 outtextxy (x1 + 40, y1 + 325,"Sek. nakl. char.   Sekundarni nakladova charakteristika distribuce");
 outtextxy (x1 + 40, y1 + 335,"Reprezentant       Reseni ulohy pomoci reprezentanta");
 outtextxy (x1 + 40, y1 + 345,"Prirazovaci        Prirazovaci uloha");
 outtextxy (x1 + 40, y1 + 365,"HKF                Hodnota kriterialni funkce");
 outtextxy (x1 + 40, y1 + 375,"Soubor             Prave otevreny soubor ulohy");
 setcolor (GREEN);
 settextstyle (3, 0, 2);
 outtextxy (x1 + 30, y1 + 425,"Zpet do prostredi programu -> Esc nebo Enter");
 int key;
 do {
  fflush (stdin);
  if (kbhit ())
   key = getch ();
 } while ((key != 27) && (key != 13));
 settextstyle (0, 0, 0);
 DrawMain ();
 int i;
 for (i = 0; i < 9; i++) Buttons[i]->Draw ();
 for (i = 0; i < 6; i++) Checks[i]->Draw ();
 Mouse.Display ();
}//Napoveda

void MouseEvents ()
{
 Mouse.GetState ();
 if (Mouse.Left) {
  int x = Mouse.X, y = Mouse.Y;
  do Mouse.GetState (); while (Mouse.Left);
  if (Buttons[0]->Inside (x, y)) bO++;
  if (Buttons[1]->Inside (x, y)) bC++;
  if (Buttons[2]->Inside (x, y)) bU++;
  if (Buttons[3]->Inside (x, y)) bStar++;
  if (Buttons[4]->Inside (x, y)) bR++;
  if (Buttons[5]->Inside (x, y)) bJ++;
  if (Buttons[6]->Inside (x, y)) bS++;
  if (Buttons[7]->Inside (x, y)) bF1++;
  if (Buttons[8]->Inside (x, y)) bEsc++;
  if (Checks[0]->Inside (x, y)) bM++;
  if (Checks[1]->Inside (x, y)) bN++;
  if (Checks[2]->Inside (x, y)) bE++;
  if (Checks[3]->Inside (x, y)) bK++;
  if (Checks[4]->Inside (x, y)) bZ++;
  if (Checks[5]->Inside (x, y)) bP++;
 }//if
}//MouseEvents

void EventHandler ()
{
 int key, nula, number = 0;
 do {
  fflush (stdin);
  nula = 0;
  if (kbhit ()) {
   key = getch ();
   if (!key) { nula = 1; key = getch (); }//if
   switch (key) { case 9 : kTab++; break;
                  case '*' : bStar++; break;
                  case 75 : if (nula)  kLeft++; break;
                  case 77 : if (nula)  kRight++; break;
                  case 72 : if (nula)  kUp++; break;
                  case 80 : if (nula)  kDown++; break;
                  case 'e' : bE++; break;
                  case 'c' : bC++; break;
                  case 'p' : bP++; break;
                  case 's' : bS++; break;
                  case 'k' : bK++; break;
                  case 'u' : bU++; break;
                  case 'j' : bJ++; break;
                  case 'n' : bN++; break;
                  case 'r' : bR++; break;
                  case 'm' : bM++; break;
                  case 'o' : bO++; break;
                  case 'z' : bZ++; break;
                  case 59 : if (nula) bF1++; break;
                  case 27 : bEsc++; break;
                }//switch
   if ((key > 47) && (key < 58)) number++;
  }//if
  MouseEvents ();
  if (number) {
   number--;
   Cislo (Tabulka.Selected.X, Tabulka.Selected.Y, key - '0', pokrac);
  }//if
  if (kTab) {
   kTab--; pokrac = 0; JeCislof ();
   if (Tabulka.Tab[Tabulka.Selected.Y][Tabulka.Selected.X].Focused == 3)
    Tabulka.Tab[Tabulka.Selected.Y][Tabulka.Selected.X].Focused = 0;
   else Tabulka.Tab[Tabulka.Selected.Y][Tabulka.Selected.X].Focused++;
   Tabulka.Tab[Tabulka.Selected.Y][Tabulka.Selected.X].Focus (Tabulka.PocX + PocrX + BoxSizeX * (Tabulka.Selected.X - Tabulka.MovedX) + 1, Tabulka.PocY + PocrY + BoxSizeY * (Tabulka.Selected.Y - Tabulka.MovedY) + 1);
  }//if
  if (bStar) { bStar--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay); SetDimension (); }//if
  if (kLeft) { kLeft--; pokrac = 0; JeCislof (); Tabulka.Move (0); }//if
  if (kRight) { kRight--; pokrac = 0; JeCislof (); Tabulka.Move (1); }//if
  if (kUp) { kUp--; pokrac = 0; JeCislof (); Tabulka.Move (2); }//if
  if (kDown) { kDown--; pokrac = 0; JeCislof (); Tabulka.Move (3); }//if
  if (bE) {
   bE--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   if (Nastaveni[2]) { Checks[2]->Uncheck (); Nastaveni[2] = 0; }//if
   else { Checks[2]->Check (); Nastaveni[2] = 1; }//else
   CountC2 ();
   Tabulka.DrawAll ();
  }//if
  if (bC) {
   bC--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay); Nacist ();
  }//if
  if (bP) {
   bP--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   if (Nastaveni[5]) { Checks[5]->Uncheck (); Nastaveni[5] = 0; }//if
   else { Checks[5]->Check (); Nastaveni[5] = 1; }//else
   for (int i = 0; i < 51; i++) for (int j = 0; j < 51; j++) {
    if (Tabulka.Tab[i][j].C != 0) Tabulka.Tab[i][j].C = 1;
    if (Tabulka.Tab[i][j].P != 0) Tabulka.Tab[i][j].P = 1;
    if (Tabulka.Tab[i][j].M != 0) Tabulka.Tab[i][j].M = 1;
    if (Tabulka.Tab[i][j].X != 0) Tabulka.Tab[i][j].X = 1;
   }//for
   Tabulka.DrawAll ();
  }//if
  if (bS) {
   bS--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   Tabulka.Centra ();
  }//if*/
  if (bZ) {
   bZ--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   if (Nastaveni[4]) { Checks[4]->Uncheck (); Nastaveni[4] = 0; }//if
   else { Checks[4]->Check (); Nastaveni[4] = 1; }//else
   CountC2 ();
  }//if
  if (bK) {
   bK--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   if (Nastaveni[3]) { Checks[3]->Uncheck (); Nastaveni[3] = 0; }//if
   else { Checks[3]->Check (); Nastaveni[3] = 1; }//else
   CountC2 ();
   Tabulka.DrawAll ();
  }//if
  if (bU) {
   bU--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay); Ulozit ();
  }//if
  if (bJ) {
   bJ--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   Tabulka.Nejlepsi ();
  }//if
  if (bN) {
   bN--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   if (!Nastaveni[1]) {
    Checks[0]->Uncheck (); Checks[1]->Check (); Nastaveni[0] = 0; Nastaveni[1] = 1;
   }//if
  }//if
  if (bR) {
   bR--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   Tabulka.Sever ();
  }//if
  if (bM) {
   bM--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay);
   if (!Nastaveni[0]) {
    Checks[0]->Check (); Checks[1]->Uncheck (); Nastaveni[0] = 1; Nastaveni[1] = 0;
   }//if
  }//if
  if (bO) {
   bO--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay); Nova ();
  }//if
  if (bF1) {
   bF1--; pokrac = 0; JeCislof (); Beep (ClickFreq, ClickDelay); Napoveda ();
  }//if
  if (bEsc) Beep (ClickFreq, ClickDelay);
  //ScrollTitle ();
 } while (!bEsc);
}//EventHandler

void Otevrit (char *soubor)
{
 char *S2 = '\0';
 strcpy (S2,Soubor);
 for (int i = 0; i < strlen (soubor) + 1; i++) Soubor[i] = soubor[i];
 int File = open (Soubor, O_RDONLY | O_BINARY);
 if (File == -1) {
  StatusLineWrite (0,"Chyba pri otevirani souboru !",0,"",0,"");
  Beep (400, 100);
  delay (2000);
  StatusLineWrite (0,"",0,"",0,"");
  strcpy (Soubor,S2);
 }//if
 else {
  char IDRet0[9];
  read (File, IDRet0, 8);
  IDRet0[8] = '\0';
  if (strcmp (IDRet, IDRet0)) {
   close (File);
   StatusLineWrite (0,"Soubor neni souborem pro tento program !",0,"",0,"");
   strcpy (Soubor,S2);
   Beep (400, 100);
   delay (2000);
   StatusLineWrite (0,"",0,"",0,"");
   Napis_Soubor (); return;
  }//if
  long sum = 8 +
  read (File, Nastaveni, sizeof Nastaveni) +
  read (File, &Tabulka.DimX, 2) +
  read (File, &Tabulka.DimY, 2) +
  read (File, Tabulka.Tab, sizeof Tabulka.Tab) +
  read (File, &Tabulka.Selected, sizeof Tabulka.Selected) +
  read (File, &Tabulka.MovedX, 2) +
  read (File, &Tabulka.MovedY, 2) +
  read (File, &Tabulka.Solved, 2);
  close (File);
  if (sum != /*41644L*/-23892) {
   StatusLineWrite (0,"Chyba pri nacitani souboru !",0,"",0,"");
   strcpy (Soubor,S2);
   Beep (400, 100);
   delay (2000);
   StatusLineWrite (0,"",0,"",0,"");
   Napis_Soubor (); return;
  }//if
  int pom[5] = {Tabulka.Selected.X, Tabulka.Selected.Y, Tabulka.MovedX, Tabulka.MovedY, Tabulka.Solved};
  Tabulka.SetDim (Tabulka.DimX, Tabulka.DimY);
  Tabulka.Selected.X = pom[0]; Tabulka.Selected.Y = pom[1]; Tabulka.MovedX = pom[2]; Tabulka.MovedY = pom[3]; Tabulka.Solved = pom[4];
  for (int i = 0; i < 6; i++)
   if (Nastaveni[i]) Checks[i]->Check ();
   else Checks[i]->Uncheck ();
  Tabulka.DrawAll ();
 }//else
}//Otevrit

void main (int argc, char *argv[])
{
 clrscr ();
 int key, Continue = 1;
 printf ("Inicializace mysi ... ");
 if (!Mouse.Init ()) {
  printf ("\r\n  Chyba : Neni nainstalovan ovladac mysi ! Pokracovat bez ni ? (a/n)\r\n");
  do {
   fflush (stdin);
   key = getch ();
   if (!key) key = getch ();
   if (key == 'n') Continue = 0;
  } while ((key != 'a') && (key != 'n'));
 }//if
 else printf ("OK");
 if (!Continue) exit (1);
 printf ("\r\nInicializace grafiky ... ");
 int gdriver = DETECT, gmode, errorcode;
 initgraph (&gdriver, &gmode, ".");
 errorcode = graphresult ();
 if (errorcode != grOk) { /* an error occurred */
  printf ("\r\n  Chyba grafiky : %s\r\n", grapherrormsg (errorcode));
  exit (1);             /* return with error code */
 }//if
 GraphOn = 1;
 Soubor = "Uloha.alk";
 DrawMain ();
 DrawButtons ();
 if (argc > 1) Otevrit (argv[1]);
 Mouse.Display ();
 EventHandler ();
 closegraph ();
 clrscr ();
 printf ("\r\n");
 clrscr ();
 printf ("Program ALOKACE je zapocet do predmetu Diskretni matematika.\r\n\r\n"
         "Dekuji za jeho pouziti !\r\n\r\n"
         "Jan Outrata - student Univerzity Palackeho, oboru Informatika\r\n"
         "            - e-mail: outrataj@inf.upol.cz\r\n"
         "1999\r\n");
}//main